<template>
	<section id="register" class="m-auto container w-full my-48">
		<h1 class="mb-5 w-2/4 m-auto text-3xl text-center">Register</h1>
		<form @submit="submitForm" class="bg-white shadow-md rounded px-8 pt-6 pb-8 mb-4 w-2/4 m-auto">
			<div class="mb-4">
				<label class="block text-sm font-bold mb-2" for="username">
					Username
				</label>
				<input class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
				       id="username"
				       type="text"
				       v-model="dataForm.username"
				       placeholder="Username"
				       required>
			</div>
			<div class="mb-4">
				<label class="block text-sm font-bold mb-2" for="username">
					Email
				</label>
				<input class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
				       id="email"
				       type="email"
				       v-model="dataForm.email"
				       placeholder="Email"
				       required>
			</div>
			<div class="mb-6">
				<label class="block text-sm font-bold mb-2" for="password">
					Password
				</label>
				<input class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
				       id="password"
				       type="password"
				       v-model="dataForm.password"
				       placeholder="••••••"
				       required>
			</div>
			<div class="flex items-center justify-between">
				<button type="submit"
				        class="transition duration-500 ease bg-red-600 hover:bg-red-700 text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline">
					Register
				</button>
			</div>
			<!-- Handle message error -->
			<div v-if="error !== null"
			     class="mt-6 bg-red-100 border border-red-400 text-red-700 px-4 py-3 rounded relative" role="alert">
				<strong class="font-bold">Une erreur est survenue!</strong>
				<span class="block sm:inline">{{error}}</span>
			</div>
		</form>
	</section>
</template>

<script>
	import {mapActions} from 'vuex'

	export default {
		data () {
			return {
				dataForm: {},
				error: null
			}
		},
		methods: {
			...mapActions([
				'register'
			]),
			submitForm: async function (e) {
				e.preventDefault()

				this.error = null

				try {
					const response = await this.register(this.dataForm)

					return this.$router.push('/login')
				} catch (e) {
					this.error = 'Vos identifiants sont invalides.'
				}
			}
		}
	}
</script>
